unit InputOutputWord;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TfmInputOutputWord = class(TForm)
    lbInputWord: TLabel;
    edInputWord: TEdit;
    lbOutputWord: TLabel;
    edOutputWord: TEdit;
    bbClose: TBitBtn;
    bbHelp: TBitBtn;
    lbInputCharsInfo: TLabel;
    lbOutCharsInfo: TLabel;
    cbxFormatOut: TCheckBox;
    procedure bbCloseClick(Sender: TObject);
    procedure edInputWordChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure cbxFormatOutClick(Sender: TObject);
    procedure bbHelpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fmInputOutputWord: TfmInputOutputWord;

implementation

uses MainForm, DAutomatons;

{$R *.DFM}

procedure TfmInputOutputWord.bbCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfmInputOutputWord.edInputWordChange(Sender: TObject);
Var
  ZMax, WMax, i, CharsCount:Integer;
  TmpStr:String;
  Z, ErCode:Integer;
  NextA, W:TStateSet;
begin
  edOutputWord.Text:='';
  MealyA.SetCurrentState(1);

  ZMax:=MealyA.GetZCount;
  WMax:=MealyA.GetWCount;

  If ZMax>=10 Then lbInputCharsInfo.Caption:=lbInputCharsInfo.Hint+' 2' Else lbInputCharsInfo.Caption:=lbInputCharsInfo.Hint+' 1';
  If WMax>=10 Then lbOutCharsInfo.Caption:=lbOutCharsInfo.Hint+' 2' Else lbOutCharsInfo.Caption:=lbOutCharsInfo.Hint+' 1';

  If ZMax>=10 Then
  Begin
    If (Length(edInputWord.Text) Mod 2)<>0 Then
    Begin
      edOutputWord.Text:='<   >';
      Exit;
    End;
  End;

  If ZMax>=10 Then
    CharsCount:=Length(edInputWord.Text) Div 2
  Else
    CharsCount:=Length(edInputWord.Text);

  If Length(edInputWord.Text)=0 Then
  Begin
    edOutputWord.Text:='<   >';
    Exit;
  End;

  For i:=1 To CharsCount Do
  Begin
    If ZMax>=10 Then
    Begin
      TmpStr:=Copy(edInputWord.Text, 2*i-1, 2);
    End
    Else Begin
      TmpStr:=Copy(edInputWord.Text, i, 1);
    End;
    Val(TmpStr, Z, ErCode);
    If ((ErCode<>0) Or (Z<1) Or (Z>ZMax)) Then
    Begin
      edOutputWord.Text:='<   >';
      Exit;
    End;
    MealyA.ProcessStep(Z, NextA, W);
    If WMax>=10 Then Str(W:2, TmpStr) Else Str(W:1, TmpStr);
    If TmpStr[1]=' ' Then TmpStr[1]:='0';
    If TmpStr='0' Then TmpStr:=ConstStrZeroState;
    If TmpStr='00' Then TmpStr:=ConstStrZeroState+ConstStrZeroState;

    If cbxFormatOut.Checked Then
      edOutputWord.Text:=edOutputWord.Text+' '+TmpStr
    Else
      edOutputWord.Text:=edOutputWord.Text+TmpStr;
  End;
end;

procedure TfmInputOutputWord.FormActivate(Sender: TObject);
begin
  edInputWord.SetFocus;
  edInputWordChange(Self);
end;

procedure TfmInputOutputWord.cbxFormatOutClick(Sender: TObject);
begin
  edInputWordChange(Self);
end;

procedure TfmInputOutputWord.bbHelpClick(Sender: TObject);
begin
  Application.MessageBox('       . '+
    '     2,        ( 01, 08, 10, 12). '+
    '       .',
    '', MB_ICONINFORMATION+MB_OK);
end;

end.

