unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Spin, Menus, AppEvnts, ComCtrls,
  ExtCtrls, Buttons, ShellAPI, DAutomatons, jpeg;

type
  TfmStateMachine = class(TForm)
    MainMenu1: TMainMenu;
    miFile: TMenuItem;
    miHelp: TMenuItem;
    miSplit1: TMenuItem;
    miExit: TMenuItem;
    miInformation: TMenuItem;
    miAbout: TMenuItem;
    miAutomaton: TMenuItem;
    miLoadAutomaton: TMenuItem;
    miSaveAutomatons: TMenuItem;
    miProcessAutomatons: TMenuItem;
    miSaveMealy: TMenuItem;
    miSaveMoore: TMenuItem;
    miSaveMinMealy: TMenuItem;
    miSaveMinMoore: TMenuItem;
    sbInfo: TStatusBar;
    miGraphs: TMenuItem;
    miMealyGraph: TMenuItem;
    miMooreGraph: TMenuItem;
    miMinMealyGraph: TMenuItem;
    miMinMooreGraph: TMenuItem;
    miSplit2: TMenuItem;
    miOutputWord: TMenuItem;
    miSplit3: TMenuItem;
    miSaveAllAutomatons: TMenuItem;
    ApplicationEvents1: TApplicationEvents;
    pnTop: TPanel;
    pcPages: TPageControl;
    tsAutomatons: TTabSheet;
    tsMinAutomatons: TTabSheet;
    tsGraphs: TTabSheet;
    gbxMealyAutomaton: TGroupBox;
    lbMealyStateCount: TLabel;
    seMealyStateCount: TSpinEdit;
    seMealyInputCount: TSpinEdit;
    lbMealyInputCount: TLabel;
    seMealyOutCount: TSpinEdit;
    lbMealyOutCount: TLabel;
    sgMealyStates: TStringGrid;
    sgMealyOuts: TStringGrid;
    gbxMooreAutomaton: TGroupBox;
    lbMooreStateCount: TLabel;
    seMooreStateCount: TSpinEdit;
    lbMooreInputCount: TLabel;
    seMooreInputCount: TSpinEdit;
    lbMooreOutCount: TLabel;
    seMooreOutCount: TSpinEdit;
    sgMooreStates: TStringGrid;
    bbProcessAutomatons: TBitBtn;
    rbtMealyToMoore: TRadioButton;
    rbtMooreToMealy: TRadioButton;
    lbMealyTableStates: TLabel;
    lbMealyTableOuts: TLabel;
    gbxMinMealyAutomaton: TGroupBox;
    lbMinMealyStates: TLabel;
    lbMinMealyOuts: TLabel;
    sgMinMealyStates: TStringGrid;
    sgMinMealyOuts: TStringGrid;
    gbxMinMooreAutomatons: TGroupBox;
    sgMinMooreStates: TStringGrid;
    bbSaveMealy: TBitBtn;
    bbClearMealy: TBitBtn;
    bbClearMoore: TBitBtn;
    bbSaveMoore: TBitBtn;
    bbLoadAutomaton: TBitBtn;
    bbSaveAllAutomatons: TBitBtn;
    pnGraphButtons: TPanel;
    bbMooreGraph: TBitBtn;
    bbMealyGraph: TBitBtn;
    bbMinMealyGraph: TBitBtn;
    bbMinMooreGraph: TBitBtn;
    odlgLoadAutomaton: TOpenDialog;
    sdlgSaveAutomaton: TSaveDialog;
    bbOutputWord: TBitBtn;
    scrbxImage: TScrollBox;
    imgGraph: TImage;
    lbBorodaHint: TLabel;
    procedure miExitClick(Sender: TObject);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure bbClearMealyClick(Sender: TObject);
    procedure rbtMealyToMooreClick(Sender: TObject);
    procedure bbClearMooreClick(Sender: TObject);
    procedure seMealyStateCountChange(Sender: TObject);
    procedure seMooreStateCountChange(Sender: TObject);
    procedure miProcessAutomatonsClick(Sender: TObject);
    procedure miOutputWordClick(Sender: TObject);
    procedure miLoadAutomatonClick(Sender: TObject);
    procedure miSaveMealyClick(Sender: TObject);
    procedure miSaveMinMealyClick(Sender: TObject);
    procedure miSaveMooreClick(Sender: TObject);
    procedure miSaveMinMooreClick(Sender: TObject);
    procedure bbSaveAllAutomatonsClick(Sender: TObject);
    procedure sgMealyStatesGetEditText(Sender: TObject; ACol,
      ARow: Integer; var Value: String);
    procedure sgMealyStatesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sgMealyStatesKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure imgGraphClick(Sender: TObject);
    procedure miAboutClick(Sender: TObject);
    procedure miInformationClick(Sender: TObject);
    procedure lbBorodaHintDblClick(Sender: TObject);
    procedure miMealyGraphClick(Sender: TObject);
    procedure miMooreGraphClick(Sender: TObject);
    procedure miMinMealyGraphClick(Sender: TObject);
    procedure miMinMooreGraphClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Procedure ShowMealyABorders;
    Procedure ReDefineMealyA;
    Procedure ShowMealyA;
    Procedure SetMealyA;

    Procedure ShowMooreABorders;
    Procedure ReDefineMooreA;
    Procedure ShowMooreA;
    Procedure SetMooreA;

    Procedure ShowMinMealyA;
    Procedure ShowMinMooreA;

    Procedure SetModified;
    Procedure SetUnModified;

    Procedure DrawGraph;
  end;

var
  fmStateMachine: TfmStateMachine;
  MealyA, MinMealyA:TMealyAutomaton;
  MooreA, MinMooreA:TMooreAutomaton;

implementation

{$R *.DFM}

uses
  InputOutputWord, graphs, FullScreen, About;

Var
  GridCol, GridRow:Integer;
  GridValue:String;

  GraphName:String;

  TemporaryDirectory:String;
  TempFileName:String;

Procedure TfmStateMachine.SetModified;
Begin
  miSaveAutomatons.Enabled:=False;
  bbSaveAllAutomatons.Enabled:=False;
  bbSaveMealy.Enabled:=False;
  bbSaveMoore.Enabled:=False;
  miOutputWord.Enabled:=False;
  bbOutputWord.Enabled:=False;
  miGraphs.Enabled:=False;

  bbMealyGraph.Enabled:=False;
  bbMooreGraph.Enabled:=False;
  bbMinMealyGraph.Enabled:=False;
  bbMinMooreGraph.Enabled:=False;
End;

Procedure TfmStateMachine.SetUnModified;
Begin
  miSaveAutomatons.Enabled:=True;
  bbSaveAllAutomatons.Enabled:=True;
  bbSaveMealy.Enabled:=True;
  bbSaveMoore.Enabled:=True;
  miOutputWord.Enabled:=True;
  bbOutputWord.Enabled:=True;
  miGraphs.Enabled:=True;

  bbMealyGraph.Enabled:=True;
  bbMooreGraph.Enabled:=True;
  bbMinMealyGraph.Enabled:=True;
  bbMinMooreGraph.Enabled:=True;
End;

Procedure TfmStateMachine.ShowMealyABorders;
Var
  a, z:Integer;
  ACnt, ZCnt, WCnt:TStateSet;
Begin
  With MealyA Do
  Begin
    ACnt:=GetACount;
    ZCnt:=GetZCount;
    WCnt:=GetWCount;

    seMealyStateCount.Value:=ACnt;
    seMealyInputCount.Value:=ZCnt;
    seMealyOutCount.Value:=WCnt;

    ReDefine(ACnt, ZCnt, WCnt);

    sgMealyStates.ColCount:=GetACount+1;
    sgMealyStates.RowCount:=GetZCount+1;
    sgMealyOuts.ColCount:=GetACount+1;
    sgMealyOuts.RowCount:=GetZCount+1;

   { }
    sgMealyStates.Cells[0, 0]:='';
    sgMealyOuts.Cells[0, 0]:='';
    For a:=1 To GetACount Do
    Begin
      sgMealyStates.Cells[a, 0]:='A'+IntToStr(a);
      sgMealyOuts.Cells[a, 0]:='A'+IntToStr(a);
    End;
    For z:=1 To GetZCount Do
    Begin
      sgMealyStates.Cells[0, z]:='Z'+IntToStr(z);
      sgMealyOuts.Cells[0, z]:='Z'+IntToStr(z);
    End;
  End;
End;

Procedure TfmStateMachine.ReDefineMealyA;
Var
  ACnt, ZCnt, WCnt:TStateSet;
Begin
  ACnt:=seMealyStateCount.Value;
  ZCnt:=seMealyInputCount.Value;
  WCnt:=seMealyOutCount.Value;

  MealyA.ReDefine(ACnt, ZCnt, WCnt);

  ShowMealyABorders;

  SetModified;
End;

Procedure TfmStateMachine.ShowMealyA;
Var
  a, z:Integer;
Begin
  With MealyA Do
  Begin
    ShowMealyABorders;
   { }
    For a:=1 To GetACount Do
    Begin
      For z:=1 To GetZCount Do
      Begin
        sgMealyStates.Cells[a, z]:=IntToStr(GetNextStateByState(a, z));
        sgMealyOuts.Cells[a, z]:=IntToStr(GetOutByState(a, z));
        If sgMealyStates.Cells[a, z]='0' Then sgMealyStates.Cells[a, z]:=ConstStrZeroState;
        If sgMealyOuts.Cells[a, z]='0' Then sgMealyOuts.Cells[a, z]:=ConstStrZeroState;
      End;
    End;
  End;
End;

Procedure TfmStateMachine.SetMealyA;
Var
  a, z:Integer;
  NextA, W:TStateSet;
  TmpStr:String;
  ErCode:Integer;
Begin
  ReDefineMealyA;
  With MealyA Do
  Begin
    For a:=1 To GetACount Do
    Begin
      For z:=1 To GetZCount Do
      Begin
        TmpStr:=sgMealyStates.Cells[a, z];
        Val(TmpStr, NextA, ErCode);
        If ErCode<>0 Then NextA:=0;
        If Not(CheckState_A(NextA)) Then NextA:=0;

        TmpStr:=sgMealyOuts.Cells[a, z];
        Val(TmpStr, W, ErCode);
        If ErCode<>0 Then W:=0;
        If Not(CheckOutput_W(W)) Then W:=0;

        InsertState(a, z, NextA, w);
      End;
    End;
  End;
  ShowMealyA;
End;


Procedure TfmStateMachine.ShowMooreABorders;
Var
  a, z:Integer;
  ACnt, ZCnt, WCnt:TStateSet;
Begin
  With MooreA Do
  Begin
    ACnt:=GetACount;
    ZCnt:=GetZCount;
    WCnt:=GetWCount;

    seMooreStateCount.Value:=ACnt;
    seMooreInputCount.Value:=ZCnt;
    seMooreOutCount.Value:=WCnt;

    ReDefine(ACnt, ZCnt, WCnt);

    sgMooreStates.ColCount:=GetACount+1;
    sgMooreStates.RowCount:=GetZCount+2;

   { }
    sgMooreStates.Cells[0, 0]:='W';
    sgMooreStates.Cells[0, 1]:='A';
    For a:=1 To GetACount Do
    Begin
      sgMooreStates.Cells[a, 1]:='A'+IntToStr(a);
    End;
    For z:=1 To GetZCount Do
    Begin
      sgMooreStates.Cells[0, z+1]:='Z'+IntToStr(z);
    End;
  End;
End;

Procedure TfmStateMachine.ReDefineMooreA;
Var
  ACnt, ZCnt, WCnt:TStateSet;
Begin
  ACnt:=seMooreStateCount.Value;
  ZCnt:=seMooreInputCount.Value;
  WCnt:=seMooreOutCount.Value;

  MooreA.ReDefine(ACnt, ZCnt, WCnt);

  ShowMooreABorders;

  SetModified;
End;

Procedure TfmStateMachine.ShowMooreA;
Var
  a, z:Integer;
Begin
  With MooreA Do
  Begin
    ShowMooreABorders;
   { }
    For a:=1 To GetACount Do
    Begin
      sgMooreStates.Cells[a, 0]:=IntToStr(GetOutByState(a, 0));
      If sgMooreStates.Cells[a, 0]='0' Then sgMooreStates.Cells[a, 0]:=ConstStrZeroState;
      For z:=1 To GetZCount Do
      Begin
        sgMooreStates.Cells[a, z+1]:=IntToStr(GetNextStateByState(a, z));
        If sgMooreStates.Cells[a, z+1]='0' Then sgMooreStates.Cells[a, z+1]:=ConstStrZeroState;
      End;
    End;
  End;
End;

Procedure TfmStateMachine.SetMooreA;
Var
  a, z:Integer;
  NextA, W:TStateSet;
  TmpStr:String;
  ErCode:Integer;
Begin
  ReDefineMooreA;
  With MooreA Do
  Begin
    For a:=1 To GetACount Do
    Begin
      TmpStr:=sgMooreStates.Cells[a, 0];
      Val(TmpStr, W, ErCode);
      If ErCode<>0 Then W:=0;
      If Not(CheckOutput_W(W)) Then W:=0;
      InsertOut(a, W);

      For z:=1 To GetZCount Do
      Begin
        TmpStr:=sgMooreStates.Cells[a, z+1];
        Val(TmpStr, NextA, ErCode);
        If ErCode<>0 Then NextA:=0;
        If Not(CheckState_A(NextA)) Then NextA:=0;

        InsertState(a, z, NextA, 0);
      End;
    End;
  End;
  ShowMooreA;
End;

Procedure TfmStateMachine.ShowMinMealyA;
Var
  a, z:Integer;
Begin
  With MinMealyA Do
  Begin
    sgMinMealyStates.ColCount:=GetACount+1;
    sgMinMealyStates.RowCount:=GetZCount+1;
    sgMinMealyOuts.ColCount:=GetACount+1;
    sgMinMealyOuts.RowCount:=GetZCount+1;

   { }
    sgMinMealyStates.Cells[0, 0]:='';
    sgMinMealyOuts.Cells[0, 0]:='';
    For a:=1 To GetACount Do
    Begin
      sgMinMealyStates.Cells[a, 0]:='A'+IntToStr(a);
      sgMinMealyOuts.Cells[a, 0]:='A'+IntToStr(a);
    End;
    For z:=1 To GetZCount Do
    Begin
      sgMinMealyStates.Cells[0, z]:='Z'+IntToStr(z);
      sgMinMealyOuts.Cells[0, z]:='Z'+IntToStr(z);
    End;
   { }
    For a:=1 To GetACount Do
    Begin
      For z:=1 To GetZCount Do
      Begin
        sgMinMealyStates.Cells[a, z]:=IntToStr(GetNextStateByState(a, z));
        sgMinMealyOuts.Cells[a, z]:=IntToStr(GetOutByState(a, z));
        If sgMinMealyStates.Cells[a, z]='0' Then sgMinMealyStates.Cells[a, z]:=ConstStrZeroState;
        If sgMinMealyOuts.Cells[a, z]='0' Then sgMinMealyOuts.Cells[a, z]:=ConstStrZeroState;
      End;
    End;
  End;
End;

Procedure TfmStateMachine.ShowMinMooreA;
Var
  a, z:Integer;
Begin
  With MinMooreA Do
  Begin
    sgMinMooreStates.ColCount:=GetACount+1;
    sgMinMooreStates.RowCount:=GetZCount+2;

   { }
    sgMinMooreStates.Cells[0, 0]:='W';
    sgMinMooreStates.Cells[0, 1]:='A';
    For a:=1 To GetACount Do
    Begin
      sgMinMooreStates.Cells[a, 1]:='A'+IntToStr(a);
    End;
    For z:=1 To GetZCount Do
    Begin
      sgMinMooreStates.Cells[0, z+1]:='Z'+IntToStr(z);
    End;
   { }
    For a:=1 To GetACount Do
    Begin
      sgMinMooreStates.Cells[a, 0]:=IntToStr(GetOutByState(a, 0));
      If sgMinMooreStates.Cells[a, 0]='0' Then sgMinMooreStates.Cells[a, 0]:=ConstStrZeroState;
      For z:=1 To GetZCount Do
      Begin
        sgMinMooreStates.Cells[a, z+1]:=IntToStr(GetNextStateByState(a, z));
        If sgMinMooreStates.Cells[a, z+1]='0' Then sgMinMooreStates.Cells[a, z+1]:=ConstStrZeroState;
      End;
    End;
  End;
End;


procedure TfmStateMachine.miExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfmStateMachine.ApplicationEvents1Hint(Sender: TObject);
begin
  sbInfo.Panels[0].Text:=Application.Hint;
end;

procedure TfmStateMachine.FormCreate(Sender: TObject);
begin
  MealyA.Init;
  MinMealyA.Init;
  MooreA.Init;
  MinMooreA.Init;

  ReDefineMealyA;

  rbtMealyToMooreClick(Self);

  miProcessAutomatonsClick(nil);

//Dirs
  TemporaryDirectory:=ExtractFilePath(ParamStr(0));
  TempFileName:='temp';
  odlgLoadAutomaton.InitialDir:=TemporaryDirectory;
  sdlgSaveAutomaton.InitialDir:=TemporaryDirectory;
end;

procedure TfmStateMachine.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  MealyA.Done;
  MinMealyA.Done;
  MooreA.Done;
  MinMooreA.Done;
end;

procedure TfmStateMachine.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
Var
  Res:Integer;
begin
  Res:=Application.MessageBox('    ?',
    ' ...', MB_ICONQUESTION+MB_YESNO);
  If Res=IDYES Then CanClose:=True Else CanClose:=False;
end;

procedure TfmStateMachine.bbClearMealyClick(Sender: TObject);
begin
  MealyA.Clear;
  ShowMealyA;
  SetModified;
end;

procedure TfmStateMachine.bbClearMooreClick(Sender: TObject);
begin
  MooreA.Clear;
  ShowMooreA;
  SetModified;
end;

procedure TfmStateMachine.rbtMealyToMooreClick(Sender: TObject);
begin
 {Enable  }
  lbMealyStateCount.Enabled:=rbtMealyToMoore.Checked;
  seMealyStateCount.Enabled:=rbtMealyToMoore.Checked;
  lbMealyInputCount.Enabled:=rbtMealyToMoore.Checked;
  seMealyInputCount.Enabled:=rbtMealyToMoore.Checked;
  lbMealyOutCount.Enabled:=rbtMealyToMoore.Checked;
  seMealyOutCount.Enabled:=rbtMealyToMoore.Checked;
  bbClearMealy.Enabled:=rbtMealyToMoore.Checked;
  If rbtMealyToMoore.Checked Then
  Begin
    sgMealyStates.Options:=sgMealyStates.Options+[goEditing];
    sgMealyOuts.Options:=sgMealyOuts.Options+[goEditing];
  End
  Else Begin
    sgMealyStates.Options:=sgMealyStates.Options-[goEditing];
    sgMealyOuts.Options:=sgMealyOuts.Options-[goEditing];
  End;

 {Enable  }
  lbMooreStateCount.Enabled:=rbtMooreToMealy.Checked;
  seMooreStateCount.Enabled:=rbtMooreToMealy.Checked;
  lbMooreInputCount.Enabled:=rbtMooreToMealy.Checked;
  seMooreInputCount.Enabled:=rbtMooreToMealy.Checked;
  lbMooreOutCount.Enabled:=rbtMooreToMealy.Checked;
  seMooreOutCount.Enabled:=rbtMooreToMealy.Checked;
  bbClearMoore.Enabled:=rbtMooreToMealy.Checked;
  If rbtMooreToMealy.Checked Then
  Begin
    sgMooreStates.Options:=sgMooreStates.Options+[goEditing];
  End
  Else Begin
    sgMooreStates.Options:=sgMooreStates.Options-[goEditing];
  End;
end;

procedure TfmStateMachine.seMealyStateCountChange(Sender: TObject);
begin
  ReDefineMealyA;
end;

procedure TfmStateMachine.seMooreStateCountChange(Sender: TObject);
begin
  ReDefineMooreA;
end;

procedure TfmStateMachine.miProcessAutomatonsClick(Sender: TObject);
begin
  If rbtMealyToMoore.Checked Then
  Begin
    SetMealyA;
   //   
    ConvertMealyToMoore(MealyA, MooreA);
   // 
    MinMealyA:=MealyA;
    MinMealyA.Minimize;
   // 
    ConvertMealyToMoore(MinMealyA, MinMooreA);
    MinMooreA.Minimize;
  End
  Else Begin
    SetMooreA;
   //   
    ConvertMooreToMealy(MooreA, MealyA);
   // 
    MinMooreA:=MooreA;
    MinMooreA.Minimize;
   // 
    ConvertMooreToMealy(MinMooreA, MinMealyA);
    MinMealyA.Minimize;
  End;

  ShowMealyA;
  ShowMooreA;
  ShowMinMealyA;
  ShowMinMooreA;

  If Sender<>nil Then
    Application.MessageBox('  .   .',
      '...', MB_ICONINFORMATION+MB_OK);

  SetUnModified;
end;

procedure TfmStateMachine.miOutputWordClick(Sender: TObject);
begin
  fmInputOutputWord.ShowModal;
end;

procedure TfmStateMachine.miLoadAutomatonClick(Sender: TObject);
Var
  F:TextFile;
  Value:TStateSet;
  ACnt, ZCnt, WCnt:TStateSet;
  a, z:Integer;
begin
  If Not(odlgLoadAutomaton.Execute) Then Exit;
  odlgLoadAutomaton.InitialDir:='';
  sdlgSaveAutomaton.InitialDir:='';

  AssignFile(F, odlgLoadAutomaton.FileName);
  ReSet(F);
 //  
  Read(F, Value);
  If Value=0 Then  // 
  Begin
    rbtMealyToMoore.Checked:=True;
    rbtMealyToMooreClick(Self);

    MealyA.Clear;
    Read(F, ACnt);
    Read(F, ZCnt);
    Read(F, WCnt);
    MealyA.ReDefine(ACnt, ZCnt, WCnt);

    For z:=1 To ZCnt Do
    Begin
      For a:=1 To ACnt Do
      Begin
        Read(F, Value);
        MealyA.InsertState(a, z, Value, 0);
      End;
    End;

    For z:=1 To ZCnt Do
    Begin
      For a:=1 To ACnt Do
      Begin
        Read(F, Value);
        MealyA.InsertState(a, z, MealyA.GetNextStateByState(a, z), Value);
      End;
    End;
    ShowMealyA;
  End
  Else Begin  // 
    rbtMooreToMealy.Checked:=True;
    rbtMealyToMooreClick(Self);

    MooreA.Clear;
    Read(F, ACnt);
    Read(F, ZCnt);
    Read(F, WCnt);
    MooreA.ReDefine(ACnt, ZCnt, WCnt);

    For a:=1 To ACnt Do
    Begin
      Read(F, Value);
      MooreA.InsertOut(a, Value);
    End;

    For z:=1 To ZCnt Do
    Begin
      For a:=1 To ACnt Do
      Begin
        Read(F, Value);
        MooreA.InsertState(a, z, Value, 0);
      End;
    End;
    ShowMooreA;
  End;
  CloseFile(F);
  miProcessAutomatonsClick(Self);
  pcPages.ActivePageIndex:=0;
end;

procedure TfmStateMachine.miSaveMealyClick(Sender: TObject);
Var
  F:TextFile;
  Value:TStateSet;
  a, z:Integer;
begin
  sdlgSaveAutomaton.Title:='  ...';
  sdlgSaveAutomaton.FilterIndex:=2;
  sdlgSaveAutomaton.DefaultExt:='mla';

  If Not(sdlgSaveAutomaton.Execute) Then Exit;

  AssignFile(F, sdlgSaveAutomaton.FileName);
  ReWrite(F);

  WriteLn(F, 0);
  WriteLn(F, MealyA.GetACount);
  WriteLn(F, MealyA.GetZCount);
  WriteLn(F, MealyA.GetWCount);

  For z:=1 To MealyA.GetZCount Do
  Begin
    For a:=1 To MealyA.GetACount Do
    Begin
      Value:=MealyA.GetNextStateByState(a, z);
      Write(F, Value);
      Write(F, ' ');
    End;
    WriteLn(F);
  End;

  For z:=1 To MealyA.GetZCount Do
  Begin
    For a:=1 To MealyA.GetACount Do
    Begin
      Value:=MealyA.GetOutByState(a, z);
      Write(F, Value);
      Write(F, ' ');
    End;
    WriteLn(F);
  End;
  CloseFile(F);
end;

procedure TfmStateMachine.miSaveMinMealyClick(Sender: TObject);
Var
  F:TextFile;
  Value:TStateSet;
  a, z:Integer;
begin
  sdlgSaveAutomaton.Title:='   ...';
  sdlgSaveAutomaton.FilterIndex:=2;
  sdlgSaveAutomaton.DefaultExt:='mla';

  If Not(sdlgSaveAutomaton.Execute) Then Exit;

  AssignFile(F, sdlgSaveAutomaton.FileName);
  ReWrite(F);

  WriteLn(F, 0);
  WriteLn(F, MinMealyA.GetACount);
  WriteLn(F, MinMealyA.GetZCount);
  WriteLn(F, MinMealyA.GetWCount);

  For z:=1 To MinMealyA.GetZCount Do
  Begin
    For a:=1 To MinMealyA.GetACount Do
    Begin
      Value:=MinMealyA.GetNextStateByState(a, z);
      Write(F, Value);
      Write(F, ' ');
    End;
    WriteLn(F);
  End;

  For z:=1 To MinMealyA.GetZCount Do
  Begin
    For a:=1 To MinMealyA.GetACount Do
    Begin
      Value:=MinMealyA.GetOutByState(a, z);
      Write(F, Value);
      Write(F, ' ');
    End;
    WriteLn(F);
  End;
  CloseFile(F);
end;

procedure TfmStateMachine.miSaveMooreClick(Sender: TObject);
Var
  F:TextFile;
  Value:TStateSet;
  a, z:Integer;
begin
  sdlgSaveAutomaton.Title:='  ...';
  sdlgSaveAutomaton.FilterIndex:=3;
  sdlgSaveAutomaton.DefaultExt:='mra';

  If Not(sdlgSaveAutomaton.Execute) Then Exit;

  AssignFile(F, sdlgSaveAutomaton.FileName);
  ReWrite(F);

  WriteLn(F, 1);
  WriteLn(F, MooreA.GetACount);
  WriteLn(F, MooreA.GetZCount);
  WriteLn(F, MooreA.GetWCount);

  For a:=1 To MooreA.GetACount Do
  Begin
    Value:=MooreA.GetOutByState(a, 0);
    Write(F, Value);
    Write(F, ' ');
  End;
  WriteLn(F);

  For z:=1 To MooreA.GetZCount Do
  Begin
    For a:=1 To MooreA.GetACount Do
    Begin
      Value:=MooreA.GetNextStateByState(a, z);
      Write(F, Value);
      Write(F, ' ');
    End;
    WriteLn(F);
  End;
  CloseFile(F);
end;

procedure TfmStateMachine.miSaveMinMooreClick(Sender: TObject);
Var
  F:TextFile;
  Value:TStateSet;
  a, z:Integer;
begin
  sdlgSaveAutomaton.Title:='   ...';
  sdlgSaveAutomaton.FilterIndex:=3;
  sdlgSaveAutomaton.DefaultExt:='mra';

  If Not(sdlgSaveAutomaton.Execute) Then Exit;

  AssignFile(F, sdlgSaveAutomaton.FileName);
  ReWrite(F);

  WriteLn(F, 1);
  WriteLn(F, MinMooreA.GetACount);
  WriteLn(F, MinMooreA.GetZCount);
  WriteLn(F, MinMooreA.GetWCount);

  For a:=1 To MinMooreA.GetACount Do
  Begin
    Value:=MinMooreA.GetOutByState(a, 0);
    Write(F, Value);
    Write(F, ' ');
  End;
  WriteLn(F);

  For z:=1 To MinMooreA.GetZCount Do
  Begin
    For a:=1 To MinMooreA.GetACount Do
    Begin
      Value:=MinMooreA.GetNextStateByState(a, z);
      Write(F, Value);
      Write(F, ' ');
    End;
    WriteLn(F);
  End;
  CloseFile(F);
end;

procedure TfmStateMachine.bbSaveAllAutomatonsClick(Sender: TObject);
begin
  miSaveMealyClick(Self);
  miSaveMinMealyClick(Self);
  miSaveMooreClick(Self);
  miSaveMinMooreClick(Self);
end;

procedure TfmStateMachine.sgMealyStatesGetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
begin
  If (Sender As TStringGrid).Tag=1 Then
  Begin
    If ARow=1 Then
    Begin
      (Sender As TStringGrid).EditorMode:=False;
      (Sender As TStringGrid).Cells[ACol, ARow]:=Value;
    End;
  End;
  GridValue:=Value;
  SetModified;
end;

procedure TfmStateMachine.sgMealyStatesKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  GridCol:=(Sender As TStringGrid).Col;
  GridRow:=(Sender As TStringGrid).Row;
end;

procedure TfmStateMachine.sgMealyStatesKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
Var
  SG:TStringGrid;
  HookKey:Boolean;
begin
  If Shift<>[] Then Exit;

  SG:=(Sender As TStringGrid);
  HookKey:=True;
  Case Key Of
    VK_ESCAPE:Begin
        SG.EditorMode:=False;
        SG.Cells[GridCol, GridRow]:=GridValue;
      End;
    VK_LEFT:Begin
        Dec(GridCol);
        If GridCol<SG.FixedCols Then GridCol:=SG.ColCount-1;
      End;
    VK_RIGHT:Begin
        Inc(GridCol);
        If GridCol>=SG.ColCount Then GridCol:=SG.FixedCols;
      End;
    VK_UP:Begin
        Dec(GridRow);
        If ((SG.Tag=1) And (GridRow=1)) Then GridRow:=0;
        If GridRow<SG.FixedRows Then GridRow:=SG.RowCount-1;
      End;
    VK_DOWN:Begin
        Inc(GridRow);
        If ((SG.Tag=1) And (GridRow=1)) Then GridRow:=2;
        If GridRow>=SG.RowCount Then GridRow:=SG.FixedRows;
      End;
    VK_RETURN:Begin
        Inc(GridRow);
        If ((SG.Tag=1) And (GridRow=1)) Then GridRow:=2;
        If GridRow>=SG.RowCount Then
        Begin
          GridRow:=SG.FixedRows;
          Inc(GridCol);
          If GridCol>=SG.ColCount Then GridCol:=SG.FixedCols;
        End;
      End;
    Else Begin
        HookKey:=False;
    End;
  End;

  If HookKey Then  //     
  Begin
    SG.Col:=GridCol;
    SG.Row:=GridRow;
  End;
end;

Procedure TfmStateMachine.DrawGraph;
Var
  MyJPEG:TJPEGImage;
  ErCode:Integer;
Begin
//dot -Tjpg temp.dot -o temp.jpg
  Screen.Cursor:=crHourGlass;
  MyJPEG:=TJPEGImage.Create;
  MyJPEG.LoadFromFile(TemporaryDirectory+'NoGraph.jpg');
  imgGraph.Picture.Assign(MyJPEG);
  Application.ProcessMessages;
  Sleep(100);
  ErCode:=ShellExecute(Handle, 'open', PChar('"'+TemporaryDirectory+'dot.exe"'+#0),
    PChar('-Tjpg '+
    '"'+TemporaryDirectory+TempFileName+'.dot" -o '+
    '"'+TemporaryDirectory+TempFileName+'.jpg"'+#0),
    PChar('"'+TemporaryDirectory+'"'+#0), SW_HIDE);
  Sleep(1000);
  Screen.Cursor:=crAppStart;
  Sleep(2000);
 {<<!!!  ( )}
//  If ErCode<=32 Then
//  Begin
{
    Application.MessageBox(
      PChar(' : '+IntToStr(ErCode)+#13#10+
            ': '+#13#10+
            '-Tjpg '+
            '"'+TemporaryDirectory+TempFileName+'.dot" -o '+
            '"'+TemporaryDirectory+TempFileName+'.jpg"'+#13#10+
            ': "'+TemporaryDirectory+'"'+#0),
      '   dot.exe???', MB_ICONERROR+MB_OK);
}      
//  End;
 {!!!  ( )>>}
  MyJPEG.LoadFromFile(TemporaryDirectory+TempFileName+'.jpg');
  imgGraph.Picture.Assign(MyJPEG);
  MyJPEG.Free;
  Screen.Cursor:=crDefault;
End;

procedure TfmStateMachine.imgGraphClick(Sender: TObject);
begin
  fmFullScreenGraph.Caption:=' - '+GraphName+' ( )';
  fmFullScreenGraph.imgGraph.Picture:=imgGraph.Picture;
  fmFullScreenGraph.ShowModal;
end;

procedure TfmStateMachine.miAboutClick(Sender: TObject);
begin
  fmAbout.ShowModal;
end;

procedure TfmStateMachine.miInformationClick(Sender: TObject);
Var
  HelpFile:String;
begin
  HelpFile:=ExtractFileDir(Application.ExeName)+'\help\html\help.html'+#0;
  ShellExecute(Handle, 'open', PChar(HelpFile), '', '', SW_SHOWNORMAL);
end;

procedure TfmStateMachine.lbBorodaHintDblClick(Sender: TObject);
begin
  Application.MessageBox(', !',
    '   :', MB_ICONERROR+MB_OK);
end;

procedure TfmStateMachine.miMealyGraphClick(Sender: TObject);
begin
  pcPages.ActivePageIndex:=2;
  GraphName:=' ';
  CreateMealyGraph(MealyA, TemporaryDirectory+TempFileName+'.dot');
  DrawGraph;
end;

procedure TfmStateMachine.miMooreGraphClick(Sender: TObject);
begin
  pcPages.ActivePageIndex:=2;
  GraphName:=' ';
  CreateMooreGraph(MooreA, TemporaryDirectory+TempFileName+'.dot');
  DrawGraph;
end;

procedure TfmStateMachine.miMinMealyGraphClick(Sender: TObject);
begin
  pcPages.ActivePageIndex:=2;
  GraphName:='  ';
  CreateMealyGraph(MinMealyA, TemporaryDirectory+TempFileName+'.dot');
  DrawGraph;
end;

procedure TfmStateMachine.miMinMooreGraphClick(Sender: TObject);
begin
  pcPages.ActivePageIndex:=2;
  GraphName:='  ';
  CreateMooreGraph(MinMooreA, TemporaryDirectory+TempFileName+'.dot');
  DrawGraph;
end;

end.

